package com.emall.flash.mobile.controller;

import com.emall.flash.bean.entity.cms.Banner;
import com.emall.flash.bean.entity.shop.CategoryBannerRel;
import com.emall.flash.bean.vo.front.Rets;
import com.emall.flash.bean.vo.node.CategoryNode;
import com.emall.flash.bean.vo.query.SearchFilter;
import com.emall.flash.service.shop.CategoryBannerRelService;
import com.emall.flash.service.shop.CategoryService;
import com.emall.flash.utils.Lists;
import com.emall.flash.web.controller.BaseController;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author ：enilu
 * @date ：Created in 11/4/2019 9:06 PM
 */
@RestController
@RequestMapping("/category")
public class CategoryController extends BaseController {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    private CategoryService categoryService;
    @Autowired
    private CategoryBannerRelService categoryBannerRelService;
    @RequestMapping(value = "/list",method = RequestMethod.GET)
    public Object list(@RequestParam(value = "tenantId",required = false) Long tenantId) {
//        List<Category> list = categoryService.queryAll(SearchFilter.build("pid", SearchFilter.Operator.ISNULL), Sort.by(Sort.Direction.ASC,"sort"))
        List<CategoryNode> list = categoryService.getCategories(tenantId,true);
        list.forEach(item->{
            List<CategoryBannerRel> relList = categoryBannerRelService.queryAll(SearchFilter.build("idCategory",item.getId()));
            List<Banner> bannerList = Lists.newArrayList();
            relList.forEach( relItem->{
                bannerList.add(relItem.getBanner());
            });

            item.setBannerList(bannerList);
        });
        return Rets.success(list);
    }
}
