package com.emall.flash.mobile.controller;


import com.emall.flash.bean.constant.factory.PageFactory;
import com.emall.flash.bean.entity.shop.ColumnsGoods;
import com.emall.flash.bean.entity.shop.Goods;
import com.emall.flash.bean.vo.front.Rets;
import com.emall.flash.bean.vo.node.ColumnsNode;
import com.emall.flash.bean.vo.query.SearchFilter;
import com.emall.flash.service.shop.ColumnsGoodsService;
import com.emall.flash.service.shop.ColumnsService;
import com.emall.flash.service.shop.GoodsService;
import com.emall.flash.service.system.ManagerService;
import com.emall.flash.utils.Lists;
import com.emall.flash.utils.factory.Page;
import com.emall.flash.web.controller.BaseController;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Sort;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 商品栏目管理
 */
@RestController
@RequestMapping("/columns/mobile")
public class ColumnsController extends BaseController {
    @Autowired
    private ColumnsService columnsService;
    @Autowired
    private ColumnsGoodsService columnsGoodsService;
    @Autowired
    private GoodsService goodsService;

    @RequestMapping(value = "/list", method = RequestMethod.GET)
    public Object list(@RequestParam(value = "tenantId", required = false) Long tenantId,
                       @RequestParam(value = "name", required = false) String name) {
        Sort sort = Sort.by(Sort.Direction.ASC, "sort");
        List<ColumnsNode> nodes = columnsService.queryAllNode(tenantId,sort);
        for (ColumnsNode node : nodes) {
            List<ColumnsNode> list = node.getChildren();
            if (list!=null&& !list.isEmpty()){
                //查询商品
                List<SearchFilter> filterList = Lists.newArrayList();
                filterList.add(SearchFilter.build("delFlag", SearchFilter.Operator.EQ,0));
                filterList.add(SearchFilter.build("columnsId",list.get(0).getId()));
                List<ColumnsGoods> columnsGoods = columnsGoodsService.queryAll(filterList);
                if (!columnsGoods.isEmpty()) {
                    Page<Goods> page = new PageFactory<Goods>().defaultPage();
                    List<Long> goodsIds = columnsGoods.stream().map(ColumnsGoods::getGoodsId).collect(Collectors.toList());
                    page.addFilter(SearchFilter.build("id", SearchFilter.Operator.IN, goodsIds));
                    if (StringUtils.isNotBlank(name))
                        page.addFilter(SearchFilter.build("name", SearchFilter.Operator.LIKE, name));
                    page.addFilter(SearchFilter.build("tenantId", tenantId));
                    page.addFilter(SearchFilter.build("isOnSale", true));
                    page.addFilter(SearchFilter.build("isDelete", false));
                    page = goodsService.queryPage(page);
                    list.get(0).setGoods(page.getRecords());
                }
            }
        }
        return Rets.success(nodes);
    }
}
