package com.emall.flash.mobile.controller;

import com.emall.flash.bean.entity.system.Complaint;
import com.emall.flash.bean.entity.system.MemberBenefits;
import com.emall.flash.bean.entity.system.User;
import com.emall.flash.bean.vo.front.Rets;
import com.emall.flash.security.JwtUtil;
import com.emall.flash.service.system.ComplaintService;
import com.emall.flash.service.system.ManagerService;
import com.emall.flash.service.system.MemberBenefitsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;

import java.util.Date;
import java.util.List;

@RestController
@RequestMapping("/mobile/memberBenefits")
public class MemberBenefitsController {

    @Autowired
    private MemberBenefitsService benefitsService;
    @Autowired
    private ComplaintService complaintService;
    @Autowired
    private ManagerService managerService;

    // 查询列表
    @RequestMapping(value = "/queryMemberBenefits",method = RequestMethod.GET)
    public Object queryMemberBenefits(MemberBenefits memberBenefits){
        List<MemberBenefits> benefits = benefitsService.queryMemberBenefits(memberBenefits,memberBenefits.getTenantId());
        return Rets.success(benefits);
    }

    /**添加投诉建议**/
    @RequestMapping(value = "/addComplaint", method = RequestMethod.POST)
    public Object add(@RequestBody Complaint complaint){
        complaint.setDelFlag(0);
        complaint.setStatus(0);
        complaint.setComplaintTime(new Date());
        complaintService.insert(complaint);
        return Rets.success(complaint.getId());
    }
}
