package com.emall.flash.mobile.controller;

import com.emall.flash.bean.constant.factory.PageFactory;
import com.emall.flash.bean.entity.shop.MessageInstance;
import com.emall.flash.bean.vo.front.Rets;
import com.emall.flash.bean.vo.query.SearchFilter;
import com.emall.flash.service.shop.MessageInstanceService;
import com.emall.flash.utils.factory.Page;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("/mobile/messageInstance")
public class MessageInstanceController {

    @Autowired
    private MessageInstanceService messageInstanceService;

    // 根据商圈获取我的消息
    @RequestMapping(value = "list/{tenantId}/{recipientId}",method = RequestMethod.GET)
    public Object list(@PathVariable("tenantId") String tenantId, @PathVariable("recipientId") String recipientId){
        Page<MessageInstance> page = new PageFactory<MessageInstance>().defaultPage();
        if (Long.valueOf(tenantId) != null) {
            page.addFilter("tenantId", SearchFilter.Operator.EQ,Long.valueOf(tenantId));
        }
        if (Long.valueOf(recipientId) != null) {
            page.addFilter("recipientId", SearchFilter.Operator.EQ,Long.valueOf(recipientId));
        }
        page.addFilter("delFlag", SearchFilter.Operator.EQ,"0");
        page.addFilter("status", SearchFilter.Operator.EQ,"1");
        Page<MessageInstance> page1 = messageInstanceService.queryPage(page);
        return Rets.success(page1);
    }
}
