package com.emall.flash.mobile.controller;


import com.emall.flash.bean.entity.system.User;
import com.emall.flash.bean.vo.front.Rets;
import com.emall.flash.security.JwtUtil;
import com.emall.flash.service.system.ManagerService;
import com.emall.flash.service.system.ModelService;
import com.emall.flash.service.system.ModelTenantService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;


@RestController
@RequestMapping("/model")
public class ModelController {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    private ModelService modelService;
    @Autowired
    private ModelTenantService modelTenantService;
    @Autowired
    private ManagerService managerService;


    /**
     * 获取商圈开通的功能键
     */
    @RequestMapping(value = "/getModelsById",method = RequestMethod.GET)
    public Object getModelsById(@RequestParam(required = false) Integer isOpen,
                                @RequestParam(required = false) Long tenantId) {
        List<Map> allMap = modelService.getModelsById(isOpen,tenantId);
        Map<String,List<Map>> map = new HashMap<>();
        List<Map> homeList = allMap.stream().filter(l -> l.get("groups").equals(1)).collect(Collectors.toList());
        map.put("home",homeList);
        List<Map> myList = allMap.stream().filter(l -> l.get("groups").equals(2)).collect(Collectors.toList());
        map.put("my",myList);
        List<Map> moreList = allMap.stream().filter(l -> l.get("groups").equals(3)).collect(Collectors.toList());
        map.put("more",moreList);
        return Rets.success(map);
    }

}
