package com.emall.flash.mobile.controller;

import com.emall.flash.bean.constant.factory.PageFactory;
import com.emall.flash.bean.core.BussinessLog;
import com.emall.flash.bean.entity.shop.Parking;
import com.emall.flash.bean.entity.system.User;
import com.emall.flash.bean.vo.front.Rets;
import com.emall.flash.bean.vo.query.SearchFilter;
import com.emall.flash.security.JwtUtil;
import com.emall.flash.service.shop.ParkingService;
import com.emall.flash.service.system.ManagerService;
import com.emall.flash.utils.Lists;
import com.emall.flash.utils.factory.Page;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Sort;
import org.springframework.web.bind.annotation.*;

import java.util.List;


@RestController
@RequestMapping("/parking/mobile")
public class ParkingController {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    private ParkingService parkingService;

    /**
     * 获取所有停车场
     */
    @RequestMapping(value = "/list",method = RequestMethod.GET)
    public Object list(@RequestParam(required = false) Long tenantId) {
        List<SearchFilter> filters = Lists.newArrayList();
        if (tenantId!=null)
            filters.add(SearchFilter.build("tenantId", tenantId));
        filters.add(SearchFilter.build("delFlag", 0));
        List<Parking> list= parkingService.queryAll(filters,Sort.by(Sort.Direction.DESC, "createTime"));
        return Rets.success(list);
    }



}
