package com.emall.flash.mobile.controller;


import com.emall.flash.bean.constant.factory.PageFactory;
import com.emall.flash.bean.constant.state.IntegralStyle;
import com.emall.flash.bean.core.BussinessLog;
import com.emall.flash.bean.entity.shop.Receipt;
import com.emall.flash.bean.entity.shop.TenantUser;
import com.emall.flash.bean.entity.shop.UserIntegral;
import com.emall.flash.bean.vo.front.Rets;
import com.emall.flash.bean.vo.query.SearchFilter;
import com.emall.flash.security.JwtUtil;
import com.emall.flash.service.shop.ReceiptService;
import com.emall.flash.service.shop.TenantUserService;
import com.emall.flash.service.shop.UserIntegralService;
import com.emall.flash.utils.Lists;
import com.emall.flash.utils.factory.Page;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Sort;
import org.springframework.web.bind.annotation.*;

import java.util.List;


@RestController
@RequestMapping("/user/receipt/mobile")
public class ReceiptController {
    private Logger logger = LoggerFactory.getLogger(getClass());

    @Autowired
    private ReceiptService receiptService;

    /**
     * 获取对获取小票记录
     */
    @RequestMapping(value = "/list",method = RequestMethod.GET)
    public Object list(@RequestParam(required = false) Long tenantId) {
        Page<Receipt> page = new PageFactory().defaultPage();
        if (tenantId!=null)
            page.addFilter(SearchFilter.build("tenantId", tenantId));
        Long idUser = JwtUtil.getUserId();
        page.addFilter(SearchFilter.build("userId", SearchFilter.Operator.EQ, idUser));
        page.addFilter(SearchFilter.build("delFlag", 0));
        page.setSort(Sort.by(Sort.Direction.DESC, "createTime"));
        page = receiptService.queryPage(page);
        return Rets.success(page);
    }

    @RequestMapping(value = "/insert",method = RequestMethod.POST)
    @BussinessLog(value = "上传小票", key = "id")
    public Object insert(@RequestBody Receipt receipt) {
        receipt.setStatus(0);
        receipt.setUserId(JwtUtil.getUserId());
        receiptService.insert(receipt);
        return Rets.success();
    }

}
