package com.emall.flash.mobile.controller;

import com.emall.flash.bean.entity.shop.Shop;
import com.emall.flash.bean.vo.front.Rets;
import com.emall.flash.bean.vo.query.SearchFilter;
import com.emall.flash.service.shop.ShopService;
import com.emall.flash.utils.Lists;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Sort;
import org.springframework.web.bind.annotation.*;

import java.util.List;


@RestController
@RequestMapping("/shop/mobile")
public class ShopController {
    private Logger logger = LoggerFactory.getLogger(getClass());
    @Autowired
    private ShopService shopService;

    //查询商家楼层
    @RequestMapping(value = "/selectShopFloor", method = RequestMethod.GET)
    public Object selectShopFloor(@RequestParam(value = "tenantId",required = false) Long tenantId,
                                  @RequestParam(value = "name",required = false) String name) {
        List<String> list = shopService.selectShopFloor(tenantId,name);
        return Rets.success(list);
    }

    //按楼层分组查询商家
    @RequestMapping(value = "/selectShopList", method = RequestMethod.GET)
    public Object selectShopList(@RequestParam(value = "name",required = false) String name,
                                 @RequestParam(value = "tenantId",required = false) Long tenantId,
                                 @RequestParam(value = "floor",required = false) String floor) {
        List<SearchFilter> filters = Lists.newArrayList();
        filters.add( SearchFilter.build("status", 1));
        filters.add( SearchFilter.build("delFlag", 0));
        if (StringUtils.isNotBlank(name))
            filters.add( SearchFilter.build("name", SearchFilter.Operator.LIKE,name));
        if (StringUtils.isNotBlank(floor))
            filters.add( SearchFilter.build("floor", SearchFilter.Operator.EQ,floor));
        if (tenantId!=null)
            filters.add( SearchFilter.build("tenantId", SearchFilter.Operator.EQ,tenantId));
        List<Shop> list = shopService.queryAll(filters, Sort.by(Sort.Direction.ASC, "sort"));
        return Rets.success(list);
    }



}
